<template>
  <div class="account-filter">
    <div class="account-filter__close" :class="{active:isOpen}" @click="showPanel">
      <span v-if="!isOpen">Развернуть фильтр</span>
      <span>
        <span v-if="!isOpen" class="refresh" @click="onUpdateFilters()">Обновить</span>
        <i :class="['icon ', isOpen ? 'chevron-up' : 'chevron-down']"/>
      </span>

    </div>
    <transition name="slideInDown">
      <template v-if="isOpen">
        <div class="account-filter__panel">
          <div class="row">
            <div class="col-xs-3 p-5">
              <ob-select
                  v-model="filters.fromLocationUuid"
                  label="Откуда"
                  placeholder="Выберите"
                  :remote-opt="api.contract.getLocations"
                  :is-auto-complete="true"
                  display-exp="russian_name"
                  class="mb20"
                  data-qa="locationFrom"
              />
            </div>
            <div class="col-xs-3 p-5">
              <ObSelect
                      v-model="filters.toLocationUuid"
                      label="Куда"
                      placeholder="Выберите"
                      :remote-opt="api.contract.getLocations"
                      :is-auto-complete="true"
                      display-exp="russian_name"
                      class="mb20"
                      data-qa="locationFrom"
              />
            </div>
            <div class="col-xs-2 p-5">
              <ob-date-picker
                  label="Погрузка от"
                  v-model="filters.afterDt"
                  ref="after-date"
              />
            </div>
            <div class="col-xs-4 account-filter__refresh">
              <div class="account-filter__refresh-button">
                <mini-loader v-show="loaderFilter"/>
                <span @click="onUpdateFilters()">Обновить</span>
              </div>
            </div>
          </div>
          <div class="row mt-20">
            <div class="col-xs-3 p-5">
              <ob-select
                      v-model="filters.resourceSpeciesUuid"
                      value-exp="uuid"
                      display-exp="title"
                      property="uuid"
                      label="Услуга"
                      placeholder="Все услуги"
                      :is-standart="true"
                      :remote-opt="meansTransport"

              />
            </div>
            <div class="col-xs-5 p-5">
              <ob-select
                      label="Тип ТС"
                      placeholder="Все типы"
                      v-model="filters.resourceTypeUuid"
                      :items="transports"
                      :disabled="!transports.length"
                      value-exp="uuid"
                      display-exp="title"
                      property="uuid"
              />
            </div>
            <div class="col-xs-1 clear-filter" @click="clearFilters()">
              <span>Очистить</span>
              <i class="icon close"/>
            </div>
            <!--<div class="col-xs-5">
              <ControlGroup
                      v-model="resource"
                      :items="listResourceClassUuid"
                      theme="light"
              />
            </div>
            <div class="col-xs-2">
              <ob-date-picker
                  label="Погрузка до"
                  v-model="filters.beforeDt"
                  ref="before-date"
              />
            </div>-->
          </div>
        </div>
      </template>
    </transition>
  </div>
</template>

<script>
  import MiniLoader from '../../components/miniLoader'
  import ObSelect from "common-components/src/obComponents/obSelect";
  // import ObRadio from "common-components/src/obComponents/obRadio";
  import ObDatePicker from "common-components/src/obComponents/obDatePickerConstructor";
  //import ControlGroup from "common-components/src/obComponents/obControlGroup";
  import api from '@/api';
  import {mapActions, mapGetters, mapMutations} from 'vuex';

  export default {
    components: {
      MiniLoader,
      ObSelect,
      ObDatePicker,
      // ObRadio
      //ControlGroup
    },
    props: {
      showButtons:{
        type: Boolean,
        default: true
      }
    },
    data() {
      return {
        searchAddress: '',
        transport: "",
        transports: [],
        api,
        isOpen: true,
        resource: null,
        listResourceClassUuid: [
          {
            label: 'Целые машины',
            value: 'e7519b46-faf4-11e9-8f0b-362b9e155667'
          },
          {
            label: 'Контейнеры',
            value: 'container',
            disabled: true
          },
          {
            label: 'Вагоны',
            value: 'wagon',
            disabled: true
          }
        ],
        filters: {
          resourceSpeciesUuid: null,
          resourceTypeUuid: null,
          resourceClassUuid: null,
          beforeDt: null,
          afterDt: null,
          fromLocationUuid: null,
          fromLocation: null,
          toLocationUuid: null,
          toLocation: null,
          searchType: 'ALL'
        },
        route: ''
      }
    },
    computed: {
      ...mapGetters({loaderFilter: 'account/loaderFilter'})
    },
    watch: {
      'filters.fromLocationUuid'(uuid) {
        this.filters.fromLocation = uuid;
      },
      'filters.toLocationUuid'(uuid) {
        this.filters.toLocation = uuid;
      },
      'filters.resourceSpeciesUuid'() {
        this.typeTransport();
      },
      $route ({name}){
        this.turnLoaderTable(true);
        switch (name) {
          case 'requests__assigning_resources':
            this.setActiveTab('ALL');
            break;
          case 'requests__executed-orders':
            this.setActiveTab('CONTRACTED');
            break;
          case 'requests__order-archive':
            this.setActiveTab('ALL'); // todo когда будет бэк реализован, заменить ALL на статус
            break;
          default:
            this.setActiveTab('ALL');
            break;
        }

      }
    },
    methods: {
      ...mapActions({
        updateFilters: 'account/updateFilters',
        changeSearchType: 'account/changeSearchType'
      }),
      ...mapMutations('account', ['setActiveTab', 'turnLoaderTable']),
      showPanel() {
        this.isOpen = !this.isOpen;
        this.$emit('changeHeight')
      },
      async meansTransport() {
        return await api.dictionaries.resources.getResourceSpeciesByClass('e7519b46-faf4-11e9-8f0b-362b9e155667')
      },
      async typeTransport() {
        if (this.filters.resourceSpeciesUuid !== null) {
          this.transports = await api.dictionaries.resources.getOrderResourcesTypesBySpecies(this.filters.resourceSpeciesUuid);
        }
      },
      onUpdateFilters () {
        this.updateFilters(this.filters)

        this.$nextTick(() => {
          this.$emit('update-filters')
        })
      },
      clearFilters() {
        let filters = this.filters
        Object.keys(filters).forEach(key => filters[key] = null)

        this.changeSearchType(this.$route.name)
        this.updateFilters(filters)

        this.resource = null

        if (this.$refs['before-date']) {
          this.$refs['before-date'].localValue = ''
        }
        if (this.$refs['after-date']) {
          this.$refs['after-date'].localValue = ''
        }
        this.transports = [];

        this.$nextTick(() => {
          this.$emit('update-filters')
        })
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/variables";

  .account-filter {
    position: relative;
    padding: 16px;
    border-bottom: 1px solid $lavender;

    &__refresh {
      display: flex;
      height: 52px;
      align-items: center;
      line-height: 20px;
      letter-spacing: 0.4px;
      color: $color-blue-navy-blue;

      &-button, &-close {
        cursor: pointer;
      }

      &-button {
        display: inherit;

        span {
          margin-left: 10px;
        }
      }
    }

    &__panel {
      margin-top: 10px;
      .row {
        margin: 5px 0;
        &.mt-20{
          margin-top: 20px;
        }
          .p-5{
            padding-right: 5px;
            padding-left: 5px;
          }
      }
      .radio-buttons {
        &__label{
          font-size: 12px;
          line-height: 12px;
          letter-spacing: 0.4px;
          color: $color-grey-span;
          margin-bottom: 10px;
        }
        &__line {
          display: flex;
          .ml17{
            margin-left: 17px;
          }
        }
      }
      .clear-filter{
        display: flex;
        align-items: center;
        cursor: pointer;
        span{
          color: $color-grey-span;
          font-size: 12px;
          line-height: 20px;
          margin-left: 10px;
        }
        .icon{
          color: $color-grey-border;
          font-size: 16px;
          line-height: 20px;
          margin-left: 8px;
        }
      }
    }

    &__close {
      display: flex;
      justify-content: space-between;
      align-items: center;
      width: 100%;
      cursor: pointer;
      color: $color-blue-navy-blue;
      font-size: 12px;
      z-index: 1;
      .refresh{
        font-size: 12px;
        margin-right: 21px;
        position: relative;
        top: -3px;
      }
      &.active{
        justify-content: flex-end;
        position: absolute;
        width: 50px;
        top: 16px;
        right: 16px;
      }
      i{
        font-size: 20px;
      }
    }
  }
</style>
